Index: GTP/trunk/Lib/Vis/Preprocessing/scripts/generate_viewcells.sh
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/scripts/generate_viewcells.sh	(revision 2535)
+++ GTP/trunk/Lib/Vis/Preprocessing/scripts/generate_viewcells.sh	(revision 2539)
@@ -8,5 +8,5 @@
 
 PROGRAM=../bin/$TARGET/Preprocessor.exe
-#PROGRAM=../bin/$TARGET/Preprocessor_itl.exe
+
 
 EXT=obj
@@ -15,6 +15,10 @@
 SCENE_PATH=../data/vienna
 
+#SCENE=arena-high-lods
+#SCENE_PATH=../data/Arena
+
+
 ENVIRONMENT=generate_viewcells.env
-LOG_PREFIX=../scripts/$SCENE
+LOG_PREFIX=$SCENE
 
 echo "starting $TARGET mode for $SCENE scene ($PROGRAM)"
@@ -22,5 +26,4 @@
 SCENE_FILENAME=$SCENE_PATH/$SCENE.$EXT
 
-OBJ_WEIGHT=20
 
 #######################################################
@@ -28,6 +31,9 @@
 METHOD=seq
 
-# the # of bvh nodes
-NODES=3000
+NODES=4000
+VIEWCELLS=4000
+#USE_HEUR=true
+USE_HEUR=false
+OBJ_WEIGHT=20
 
  
@@ -42,6 +48,10 @@
  -hierarchy_subdivision_stats=$LOG_PREFIX-$METHOD-hierarchy-subdivisionStats.log \
  -hierarchy_construction_type=0 \
- -vsp_use_cost_heuristics=false \
- -bvh_term_max_leaves=$NODES
+ -view_cells_triangle_weight=1.0 \
+ -view_cells_object_weight=$OBJ_WEIGHT \
+ -vsp_use_cost_heuristics=$USE_HEUR \
+ -bvh_term_max_leaves=$NODES \
+ -vsp_term_max_view_cells=$VIEWCELLS
 
 sh movefiles.sh $LOG_PREFIX-$METHOD
+
Index: GTP/trunk/Lib/Vis/Preprocessing/scripts/gi_final.sh
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/scripts/gi_final.sh	(revision 2535)
+++ GTP/trunk/Lib/Vis/Preprocessing/scripts/gi_final.sh	(revision 2539)
@@ -8,5 +8,4 @@
 
 PROGRAM=../bin/$TARGET/Preprocessor.exe
-#PROGRAM=../bin/$TARGET/Preprocessor_itl.exe
 
 EXT=obj
Index: GTP/trunk/Lib/Vis/Preprocessing/scripts/generate_viewcells.env
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/scripts/generate_viewcells.env	(revision 2537)
+++ GTP/trunk/Lib/Vis/Preprocessing/scripts/generate_viewcells.env	(revision 2539)
@@ -7,9 +7,4 @@
 
 	filename ../data/vienna/vienna_cropped.obj
-#	filename ../data/soda/soda.dat
-#	filename ../data/soda/soda5.dat
-#	filename ../data/artificial/cube_test.x3d
-#	filename ../data/CityModel.obj
-#	filename ../data/arena/arena-low-lods.obj
 }
 
@@ -21,8 +16,6 @@
 	loadMeshes false
 	
-	# internal raycaster
+	# internal raycaster: 0, intel: 1
 	rayCastMethod 0  
-	# intel raycaster
-	#rayCastMethod 1
 	
 	exportVisibility false
@@ -32,53 +25,12 @@
 
 
-RssPreprocessor {
-	distributions mutation+spatial+object_direction
-	#distributions spatial
-
-
-	useImportanceSampling true
-
-	Export {
-		pvs false
-		rssTree false
-	}
-
-	useViewcells true
-	updateSubdivision true
-	loadInitialSamples false
-	storeInitialSamples false
-
-	useRssTree true
-}
-
-
-
 VssTree {
-	useRss    	false
-	epsilon		1e-6
-	
 	maxDepth 	2
-	minPvs		30
-	minRays		800
-	minSize		0.001
- 	maxCostRatio	1.5
-	maxRayContribution 0.5
-		
+	
 	maxTotalMemory	50
 	maxStaticMemory	20
 	
 	splitType regular
-	#	splitType heuristic
-	#	splitType hybrid
 	splitUseOnlyDrivingAxis true
-	
-	interleaveDirSplits	true
-    	dirSplitDepth 0
-	
-	numberOfEndPointDomains	10000
-	ct_div_ci	0.0
-	randomize	false
-	
-	refDirBoxMaxSize	0.1
 }
 
@@ -88,9 +40,4 @@
        small		1e-6
        infinity		1e9
-}
-
-
-Unigraphics {
-	meshGrouping 1
 }
 
@@ -107,5 +54,4 @@
 	}
 
-#	splitMethod spatialMedian
 	splitMethod SAH
 	splitBorder 0.01
@@ -120,5 +66,4 @@
 	}
 
-#	splitMethod spatialMedian
 	splitMethod SAH
 	splitBorder 0.01
@@ -146,5 +91,5 @@
 	type vspOspTree
 	
-	#percentage of total visible objects where pvs is considered invalid
+	#this ratio of the biggest pvs gives the threshold when a pvs is considered invalid
 	maxPvsRatio 1.0
 		
@@ -175,9 +120,9 @@
 	}
 
-	showVisualization true
-	#showVisualization false
+	#showVisualization true
+	showVisualization false
 	evaluateViewCells false
 	
-	
+
 	Evaluation {
 		samples         80000000
@@ -210,9 +155,9 @@
 	Termination {
 		minPvs 0
-		maxViewCells 500000
-	}
-
+		maxViewCells 4000
+	}
+
+	# heuristics for computing local split planes
 	useCostHeuristics false
-	splitUseOnlyDrivingAxis false
 
 	# maximum number of tests per node
@@ -230,14 +175,16 @@
 	Construction {		
 		renderCostDecreaseWeight 0.999
-	}
-
-	Termination {
-		maxLeaves 3000
+		#renderCostDecreaseWeight 1.0
+	}
+
+	Termination {
+		maxLeaves 4000
 	}
 
 	minRaysForVisibility 3
-	#minRaysForVisibility 15
-
-	useCostHeuristics false
+
+	# heuristics for computing local split planes
+	useCostHeuristics true
+	# surface area or visibility based heuristics
 	useSah false
 
@@ -281,7 +228,8 @@
 	Termination {
 		# maximal number of leaves
-		maxLeaves 30000
+		maxLeaves 300000
 		# maximal memory in MB
-		maxMemory 17
+                # maxMemory 4
+		maxMemory 200
 		# minimum ratio of global cost decrease
 		minGlobalCostRatio -1